from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, Float, Boolean

Megahit_Core_Popcnt_Assemble_V0_1_0 = CommandToolBuilder(tool="megahit_core_popcnt_assemble", base_command=["megahit_core_popcnt", "assemble"], inputs=[ToolInput(tag="in_s_dbg_name", input_type=String(optional=True), prefix="--sdbg_name", doc=InputDocumentation(doc="succinct de Bruijn graph name")), ToolInput(tag="in_output_prefix", input_type=String(optional=True), prefix="--output_prefix", doc=InputDocumentation(doc="(=out)         output prefix")), ToolInput(tag="in_num_cpu_threads", input_type=Int(optional=True), prefix="--num_cpu_threads", doc=InputDocumentation(doc="(=0)         number of cpu threads")), ToolInput(tag="in_max_tip_len", input_type=Int(optional=True), prefix="--max_tip_len", doc=InputDocumentation(doc="(=-1)            max length for tips to be removed. -1 for 2k")), ToolInput(tag="in_min_standalone", input_type=Int(optional=True), prefix="--min_standalone", doc=InputDocumentation(doc="(=200)        min length of a standalone contig to output to final.contigs.fa")), ToolInput(tag="in_bubble_level", input_type=Int(optional=True), prefix="--bubble_level", doc=InputDocumentation(doc="(=2)            bubbles level 0-3")), ToolInput(tag="in_merge_len", input_type=Int(optional=True), prefix="--merge_len", doc=InputDocumentation(doc="(=20)              merge complex bubbles of length <= merge_len * k")), ToolInput(tag="in_merge_similar", input_type=Int(optional=True), prefix="--merge_similar", doc=InputDocumentation(doc="(=0.98)        min similarity of complex bubble merging")), ToolInput(tag="in_prune_level", input_type=Int(optional=True), prefix="--prune_level", doc=InputDocumentation(doc="(=2)             strength of low local depth contig pruning (0-3)")), ToolInput(tag="in_disconnect_ratio", input_type=Float(optional=True), prefix="--disconnect_ratio", doc=InputDocumentation(doc="(=0.1)      ratio threshold for disconnecting contigs")), ToolInput(tag="in_low_local_ratio", input_type=Float(optional=True), prefix="--low_local_ratio", doc=InputDocumentation(doc="(=0.2)       ratio to define low depth contigs")), ToolInput(tag="in_cleaning_rounds", input_type=Int(optional=True), prefix="--cleaning_rounds", doc=InputDocumentation(doc="(=5)         number of rounds of graphs cleaning")), ToolInput(tag="in_min_depth", input_type=Int(optional=True), prefix="--min_depth", doc=InputDocumentation(doc="(=-1)              if prune_level >= 2, permanently remove low local coverage unitigs under this threshold")), ToolInput(tag="in_is_final_round", input_type=Boolean(optional=True), prefix="--is_final_round", doc=InputDocumentation(doc="this is the last iteration")), ToolInput(tag="in_output_standalone", input_type=Boolean(optional=True), prefix="--output_standalone", doc=InputDocumentation(doc="output standalone contigs to *.final.contigs.fa")), ToolInput(tag="in_careful_bubble", input_type=Boolean(optional=True), prefix="--careful_bubble", doc=InputDocumentation(doc="remove bubble carefully")), ToolInput(tag="in_assemble", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Megahit_Core_Popcnt_Assemble_V0_1_0().translate("wdl", allow_empty_container=True)

